;-----------------------------------------------------------------------
; DateiName        :  noedit.asm
;-----------------------------------------------------------------------
; Autor            :  Christian Roesch
;
; Erstellungsdatum :  11.11.2001
;-----------------------------------------------------------------------
; Info : Das ist kein Text-Editor. Nichtmal ne billige Kopie davon...
;-----------------------------------------------------------------------


; Dies ist das Daten-Segment

data SEGMENT
assume DS:data
press    db "press any key 2 start. press ESC 2 quit.",13,10,"$"
data ends



; Dies ist das Stack-Segment

stackdata SEGMENT stack
assume SS:stackdata
        db 256 dup(?)           ; definiert die Grsse des Stacks
stackdata ends



; Dies ist das Code-Segment

code SEGMENT
ASSUME CS:code

start:                          ; hier beginnt die Abarbeitung des Programms
        mov     ax, data        ; Adresse des Daten Segments nach ax
        mov     ds, ax          ; DatenSegment nach ds

        mov     dx,OFFSET press ; Offset des Textes nach dx
        mov     ax,0900h        ; Funktion 0900h (String ausgeben)
        int     21h             ; Interrupt auslsen

intro:
        mov     ah,01h          ; Tastaturbuffer checken
        int     16h
        jz      intro           ; warten bis Taste gedrckt

        mov     ah,02h          ; Cursor setzen
        xor     bx,bx           ; Seite 0
        xor     dx,dx           ; obere Ecke
        int     10h

        mov     ax,0a20h        ; LeerZeichen ausgeben
        mov     cx,2000         ; dann ist der Bildschirm leer
        int     10h
        mov     cx,1            ; nur noch einzelne Zeichen ab jetzt

wait4keys:
        mov     ah,01h          ; Tastaturbuffer checken
        int     16h
        jz      wait4keys       ; warten bis Taste gedrckt
        xor     ah,ah           ; Tastaturbuffer lesen
        int     16h

        cmp     al,27
        jz      ende            ; bei ESC beenden

        cmp     al,13
        jnz     noenter         ; kein ENTER => berspringen
        mov     dl,79           ; Cursor ganz hinter
        jmp     move_cur        ; und bewegen ;)
noenter:
        cmp     al,8
        jnz     nodelete        ; kein DELETE => berspringen

        mov     ah,02h          ; Cursor setzen
        dec     dl              ; eins zurck
        jge     del_ok          ; grsser 0, dann ok
        mov     dl,79           ; Spalte 79
        dec     dh              ; Zeile verringern
        jge     del_ok          ; grsser 0, dann ok
        mov     dh,24           ; sonst ganz runter
del_ok:
        int     10h
        mov     ax,0a20h        ; LeerZeichen ausgeben
        int     10h
        jmp     wait4keys       ; nchsten Tastendruck abwarten

nodelete:
        cmp     al,' '          ; kleiner ' '(darunter sind Steuerzeichen)
        jb      wait4keys       ; dann zurck

        mov     ah,0ah          ; Zeichen ausgeben
        int     10h

move_cur:
        mov     ah,02h          ; Cursor setzen
        inc     dl              ; eins weiter
        cmp     dl,80           ; kleiner 80
        jb      pos_ok          ; dann ok
        xor     dl,dl           ; Spalte 0
        inc     dh              ; Zeile erhhen
        cmp     dh,25           ; kleiner 25
        jb      pos_ok          ; dann ok
        xor     dh,dh           ; sonst wieder hoch
pos_ok:
        int     10h
        jmp     wait4keys
ende:
        mov     ax, 4c00h       ; Funktion 4c00h (Programmende)
        int     21h             ; Interuppt auslsen


code ENDS



     end     start              ; Start als Einsprungpunkt definieren

;-----
; EOF
;-----
